﻿
#Überwacht die Replikation (Hyper-V Repilca)
#Schickt ein Mail mit den Ergebnissen der Replikation
#Thorsten Jarz

$Betreff="Hyper-V Replica: "
$Empfaenger="empfaenger1@meinschule.at,empfaenger2@meinschule.at"
$Sender="sicherung@meineschule.at"
$Username="maildienst@meienschule.at"; $Password="Kennwort" 
$SMTPServer="smtp.office365.com"; $SSL="True"; $Port=587

if ((Get-VMReplication | select-string -inputobject {$_.Health} -pattern “Warning”) -like “Warning”)
	{$Fehler="Warnung" }
elseif ((Get-VMReplication | select-string -inputobject {$_.Health} -pattern “Critical”) -like “Critical”)
	{$Fehler="Kritisch"}
else
	{$Fehler="OK"}

$ergebnis = Measure-VMReplication | ConvertTo-HtML -Property Name,State,Health,LastReplicationTime,AverageReplicationLatency,SuccReplCount,PendingReplicationSize,AverageReplicationSize,MaximumReplicationLatency,MissedReplicationCount,CurrentReplicaServerName 

$HTMLFile = @"
<html>
<head>
<style>TABLE{border-width: 1px;border-style: solid;border-collapse: collapse} TH{border-width: 2px;padding: 5px;border-style: solid}
	TD{border-width: 2px;padding: 5px;border-style: solid}</style>
</head>
<body>
<H1> $Betreff $Fehler</H1>
$ergebnis 
</body>
</html>
"@

# Email  
if($SMTPServer -ne "None")
	{$msg = new-object Net.Mail.MailMessage
	$smtp = new-object Net.Mail.SmtpClient($SMTPServer,$Port)
	
	$msg.From = $Sender
	$msg.ReplyTo = $Sender
	ForEach($mail in $Empfaenger)
	{
		$msg.To.Add($mail)
	}
	if ($Username -ne "None" -and $Password -ne "None")
	{
		$cred = new-object System.Net.NetworkCredential
		$cred.UserName =  $Username; $cred.Password = $Password
		$smtp.Credentials = $cred
	}
	if ($SSL -ne "False")
		{ $smtp.EnableSsl = $true }
	$msg.subject =( $Betreff + $Fehler)
	$msg.body = $HTMLFile
	$msg.IsBodyHtml = $true
	try{
		Write-Output "Sende E-mail" 
		$smtp.Send($msg) 
	   }
	catch{
		Write-Host "Fehler beim Senden" -ForegroundColor Red
		write-host "Type: $($_.Exception.GetType().FullName) `n Meldung: $($_.Exception.Message)" -ForegroundColor Red 
		}
	}